## flightgear 2.6.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6.4)

include (CheckFunctionExists)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckIncludeFile)

project(FlightGear)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

if(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # use official include provided by latest CMake
    include(GNUInstallDirs)
else(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # backward compatibility: use our own module for older cmake versions
    include(OldGNUInstallDirs)
endif(${CMAKE_VERSION} VERSION_GREATER 2.8.4)

set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "add a postfix, usually d on windows")
set(CMAKE_RELEASE_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ version versionFile)
string(STRIP ${versionFile} FLIGHTGEAR_VERSION) 

#packaging
if(EXISTS ${PROJECT_SOURCE_DIR}/.gitignore)
    file(READ .gitignore CPACK_SOURCE_IGNORE_FILES)
else()
    # clean tar-balls do not contain SCM (.git/.gitignore/...) files.
    set(CPACK_SOURCE_IGNORE_FILES
      "Makefile.am;~$;${CPACK_SOURCE_IGNORE_FILES}")
endif()

list (APPEND CPACK_SOURCE_IGNORE_FILES "${PROJECT_SOURCE_DIR}/.git;\\\\.gitignore")

# split version string into components, note CMAKE_MATCH_0 is the entire regexp match
string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" CPACK_PACKAGE_VERSION ${FLIGHTGEAR_VERSION} )
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1}) 
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_3})
SET(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README")

set(CPACK_SOURCE_GENERATOR TBZ2)
set(CPACK_SOURCE_PACKAGE_FILE_NAME "flightgear-${FLIGHTGEAR_VERSION}" CACHE INTERNAL "tarball basename")

include (CPack)

if (FG_DATA_DIR)
    message(STATUS "Using explicit data-dir: ${FG_DATA_DIR}")
else()
    set(FG_DATA_DIR "${CMAKE_INSTALL_PREFIX}/lib/FlightGear" CACHE PATH "Default location where data files are located")
    message(STATUS "Using default data-dir:  ${FG_DATA_DIR}")
endif()

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(NOT "$ENV{BUILD_ID}" STREQUAL "")
	set(HUDSON_BUILD_ID $ENV{BUILD_ID})
	set(HUDSON_BUILD_NUMBER $ENV{BUILD_NUMBER})
	message(STATUS "running under Hudson, build-number is ${HUDSON_BUILD_NUMBER}")
else()
	set(HUDSON_BUILD_NUMBER 0)
	set(HUDSON_BUILD_ID "none")
endif()

IF(APPLE)
    set(EVENT_INPUT_DEFAULT 1)
    
    find_library(CORESERVICES_LIBRARY CoreServices)
    find_library(COCOA_LIBRARY Cocoa)
    list(APPEND PLATFORM_LIBS ${COCOA_LIBRARY} ${CORESERVICES_LIBRARY})

elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	find_package(UDev)

	if(UDEV_FOUND)
		set(EVENT_INPUT_DEFAULT 1)
	endif(UDEV_FOUND)
endif()

find_package(Git)
if (GIT_FOUND)
	execute_process(COMMAND git --git-dir ${PROJECT_SOURCE_DIR}/.git rev-parse  HEAD
		OUTPUT_VARIABLE REVISION
		OUTPUT_STRIP_TRAILING_WHITESPACE)
	message(STATUS "Git revision is ${REVISION}")
else()
	set(REVISION "none")
endif()

option(LOGGING "Set to OFF to build FlightGear without logging" ON)

option(SP_FDMS "Set to ON to build FlightGear with special-purpose FDMs" OFF)
option(ENABLE_UIUC_MODEL "Set to ON to build FlightGear with UIUCModel FDM" OFF)
option(ENABLE_LARCSIM "Set to ON to build FlightGear with LaRCsim FDM" OFF)
option(ENABLE_YASIM "Set to ON to build FlightGear with YASIM FDM" ON)
option(ENABLE_JSBSIM "Set to ON to build FlightGear with JSBSim FDM" ON)
option(ENABLE_FGADMIN "Set to ON to build FlightGear with FGADMIN" ON)
option(EVENT_INPUT "Set to ON to build FlightGear with event-based Input support" ${EVENT_INPUT_DEFAULT})
option(ENABLE_LIBSVN "Set to ON to build FlightGear/terrasync with libsvnclient support" ON)
option(ENABLE_RTI "Set to ON to build SimGear with RTI support" OFF)
option(WITH_FGPANEL "Set to ON to build the fgpanel application" ON)
option(JPEG_FACTORY "Enable JPEG-factory support" OFF)

if (MSVC)
  GET_FILENAME_COMPONENT(PARENT_DIR ${PROJECT_SOURCE_DIR} PATH)
  if (CMAKE_CL_64)
    SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty.x64")
  else (CMAKE_CL_64)
    SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty")
  endif (CMAKE_CL_64)
  if (EXISTS ${TEST_3RDPARTY_DIR})
    set(MSVC_3RDPARTY_ROOT ${PARENT_DIR} CACHE PATH "Location where the third-party dependencies are extracted")
  else (EXISTS ${TEST_3RDPARTY_DIR})
    set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
  endif (EXISTS ${TEST_3RDPARTY_DIR})
  list(APPEND PLATFORM_LIBS "winmm.lib")
else (MSVC)
  set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
endif (MSVC)

if(LOGGING)
	# nothing
else()
	set(FG_NDEBUG 1)
endif()

if(SP_FDMS)
	set(ENABLE_SP_FDM 1)
endif()

if (MSVC AND MSVC_3RDPARTY_ROOT)
  message(STATUS "3rdparty files located in ${MSVC_3RDPARTY_ROOT}")
  set( OSG_MSVC "msvc" )
  if (${MSVC_VERSION} EQUAL 1600)
      set( OSG_MSVC ${OSG_MSVC}100 )
  else (${MSVC_VERSION} EQUAL 1600)
      set( OSG_MSVC ${OSG_MSVC}90 )
  endif (${MSVC_VERSION} EQUAL 1600)
  if (CMAKE_CL_64)
      set( OSG_MSVC ${OSG_MSVC}-64 )
	  set( MSVC_3RDPARTY_DIR 3rdParty.x64 )
  else (CMAKE_CL_64)
	  set( MSVC_3RDPARTY_DIR 3rdParty )
  endif (CMAKE_CL_64)

  set (CMAKE_LIBRARY_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/lib ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenScenegraph/lib ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/SimGear/lib )
  set (CMAKE_INCLUDE_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenScenegraph/include ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/SimGear/include)
  set (BOOST_ROOT ${MSVC_3RDPARTY_ROOT}/boost_1_44_0)
  set (OPENAL_INCLUDE_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include)
  set (ALUT_INCLUDE_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include)
  set (OPENAL_LIBRARY_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/lib)
endif (MSVC AND MSVC_3RDPARTY_ROOT)

if(EVENT_INPUT)
	message(STATUS "checking event-based Input")

	IF(APPLE)

	elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
		if(NOT UDEV_FOUND)
			message(WARNING "UDev not found, event input is disabled!")
			set(EVENT_INPUT 0)
		else()
			set(EVENT_INPUT_LIBRARIES ${UDEV_LIBRARIES})
		endif()

	else()
		message(WARNING "event input is not supported on this platform yet")
	endif()

	# Keep PLIB INPUT enabled as long as EventInput does not replace current joystick configurations.
	set(ENABLE_PLIB_JOYSTICK 1)
else(EVENT_INPUT)
	set(ENABLE_PLIB_JOYSTICK 1)
endif(EVENT_INPUT)

# check required dependencies
find_package(Boost REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Threads REQUIRED)
find_package(OpenGL REQUIRED)
find_package(OpenAL REQUIRED)
find_package(ALUT REQUIRED)
find_package(OpenSceneGraph 3.0.0 REQUIRED osgText osgSim osgDB osgParticle osgFX osgUtil osgViewer osgGA)

if(ENABLE_FGADMIN)
	find_package(FLTK)

	if ( FLTK_FOUND )
		if ( X11_Xinerama_FOUND )
			message(STATUS "Found X11_Xinerama...")
			list(APPEND FLTK_LIBRARIES ${X11_Xinerama_LIB})
		endif()

		if ( X11_Xft_FOUND )
			message(STATUS "Found X11_Xft...")
			list(APPEND FLTK_LIBRARIES ${X11_Xft_LIB})
		endif()

		set( CMAKE_REQUIRED_INCLUDES ${FLTK_INCLUDE_DIR} )
		set( CMAKE_REQUIRED_LIBRARIES ${FLTK_LIBRARIES} )

		message(STATUS "Using FLTK_LIBRARIES for fgadmin: ${FLTK_LIBRARIES}")
	endif ( FLTK_FOUND )
endif(ENABLE_FGADMIN)

if(ENABLE_LIBSVN)
	find_package(SvnClient)
	
	if(LIBSVN_FOUND)
		message(STATUS "libsvn found, enabling in terrasync")
		set(HAVE_SVN_CLIENT_H 1)
		set(HAVE_LIBSVN_CLIENT_1 1)
	endif(LIBSVN_FOUND)
endif(ENABLE_LIBSVN)

find_package(PLIB REQUIRED puaux pu js fnt)
find_package(SimGear 2.6.0 REQUIRED)

if (JPEG_FACTORY)
    # check simgear was built with JPEG-factory support
    find_package(JPEG REQUIRED)
    include_directories(${JPEG_INCLUDE_DIR})
    
    set(CMAKE_REQUIRED_INCLUDES 
        ${SIMGEAR_INCLUDE_DIR} 
        ${JPEG_INCLUDE_DIR} 
        ${OPENSCENEGRAPH_INCLUDE_DIRS})
        
    check_cxx_source_compiles(
        "#include <simgear/screen/jpgfactory.hxx>
        int main()    { return 0; } "
        FG_JPEG_SERVER)
        
    if (NOT FG_JPEG_SERVER)
        message(STATUS "JPEG server support requested, but SimGear was built without JPEG support")
    endif()
endif()

check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(windows.h HAVE_WINDOWS_H)

# definition depends on OSG version
set(CMAKE_REQUIRED_INCLUDES ${OPENSCENEGRAPH_INCLUDE_DIRS})

check_cxx_source_compiles(
    "#include <osg/CullSettings>
    int main()
    {
       osg::CullSettings::VariablesMask mask = osg::CullSettings::CLEAR_MASK;
       return 0;
    }
    "
    HAVE_CULLSETTINGS_CLEAR_MASK)

if(ENABLE_RTI)
    find_package(RTI)
    if(RTI_FOUND)
        set(FG_HAVE_HLA 1)
    endif(RTI_FOUND)
endif(ENABLE_RTI)

if(CMAKE_COMPILER_IS_GNUCXX)
    set(WARNING_FLAGS -Wall)
endif(CMAKE_COMPILER_IS_GNUCXX)

if(WIN32)

    if(MSVC)
        # turn off various warnings
        # foreach(warning 4244 4251 4267 4275 4290 4786 4305 4996)
        #     SET(WARNING_FLAGS "${WARNING_FLAGS} /wd${warning}")
        # endforeach(warning)
        
        set(MSVC_FLAGS "-DNOMINMAX -D_USE_MATH_DEFINES -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS -D__CRT_NONSTDC_NO_WARNINGS")
        if (${MSVC_VERSION} EQUAL 1600)
		  set( MSVC_LD_FLAGS "/FORCE:MULTIPLE" )
        endif (${MSVC_VERSION} EQUAL 1600)
    endif(MSVC)

    set(NOMINMAX 1)
endif(WIN32)    

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${WARNING_FLAGS} ${MSVC_FLAGS} -D_REENTRANT")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_FLAGS} ${MSVC_FLAGS} -D_REENTRANT")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${MSVC_LD_FLAGS}")

include_directories(${OPENSCENEGRAPH_INCLUDE_DIRS}
	${Boost_INCLUDE_DIRS}
	${ZLIB_INCLUDE_DIR}
	${ALUT_INCLUDE_DIR}
	${OPENGL_INCLUDE_DIR}
	${OPENAL_INCLUDE_DIR}
	${SIMGEAR_INCLUDE_DIR}
	${PLIB_INCLUDE_DIR} )

include_directories(${PROJECT_SOURCE_DIR}/src)

# following is needed, because config.h is include 'bare', whereas
# version.h is included as <Include/version.h> - this should be cleaned up
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src/Include)

add_definitions(-DHAVE_CONFIG_H)

check_function_exists(mkfifo HAVE_MKFIFO)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/src/Include/config_cmake.h.in"
  "${PROJECT_BINARY_DIR}/src/Include/config.h"
  )

#and the same for the version header
configure_file (
  "${PROJECT_SOURCE_DIR}/src/Include/version.h.cmake-in"
  "${PROJECT_BINARY_DIR}/src/Include/version.h"
  ) 

add_subdirectory(src)
add_subdirectory(utils)
add_subdirectory(man)

set (INSTALL_DOCS 
	README
	README.OpenAL
	README.plib
	README.OSG
	README.SimGear)

INSTALL(FILES ${INSTALL_DOCS} DESTINATION ${CMAKE_INSTALL_DOCDIR} OPTIONAL)

#-----------------------------------------------------------------------------
### uninstall target
#-----------------------------------------------------------------------------
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== man/CMakeLists.txt ===
if(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # use official include provided by latest CMake
    include(GNUInstallDirs)
else(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
    # backward compatibility: use our own module for older cmake versions
    include(OldGNUInstallDirs)
endif(${CMAKE_VERSION} VERSION_GREATER 2.8.4)

set(MANPAGES
    fgfs.1
    fgjs.1
    fgpanel.1
    gl-info.1
    js_demo.1
    terrasync.1)

# map some variables to what the man-pages expect
set(PACKAGE ${CMAKE_PROJECT_NAME})
set(VERSION ${FLIGHTGEAR_VERSION})

foreach(man ${MANPAGES})
    configure_file (
        "${PROJECT_SOURCE_DIR}/man/${man}.in"
        "${PROJECT_BINARY_DIR}/man/${man}"
        )

    install(FILES ${PROJECT_BINARY_DIR}/man/${man}
          DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT doc)
endforeach()

=== src/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR})

# note order here affects link order, and hence linking correctness
# on systems with a traditional ld (eg, GNU ld on Linux)
foreach( mylibfolder 
		Airports
		Aircraft
		ATC
		ATCDCL
		Radio
		Autopilot
		Cockpit
		Environment
		GUI
		Input
		Instrumentation
		Model
		MultiPlayer
		AIModel
		Navaids
		Network
		Scenery
		Scripting
		Sound
		Systems
		Time
		Traffic
		FDM
		Main
    )

    add_subdirectory(${mylibfolder})
endforeach( mylibfolder )

=== src/Aircraft/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	controls.cxx
	replay.cxx
	flightrecorder.cxx
	)

set(HEADERS
	controls.hxx
	replay.hxx
	flightrecorder.hxx
	)


flightgear_component(Aircraft "${SOURCES}" "${HEADERS}")

=== src/FDM/CMakeLists.txt ===
include(FlightGearComponent)

if(SP_FDMS)
set(SP_FDM_SOURCES
	SP/ACMS.cxx
	SP/ADA.cxx
	SP/Balloon.cxx
	SP/BalloonSim.cpp
	SP/MagicCarpet.cxx
	)
endif()

set(UIUC_SOURCES
	uiuc_1DdataFileReader.cpp
	uiuc_1Dinterpolation.cpp
	uiuc_2DdataFileReader.cpp
	uiuc_2Dinterpolation.cpp
	uiuc_3Dinterpolation.cpp
	uiuc_aerodeflections.cpp
	uiuc_alh_ap.cpp
	uiuc_auto_pilot.cpp
	uiuc_betaprobe.cpp
	uiuc_coef_drag.cpp
	uiuc_coef_lift.cpp
	uiuc_coef_pitch.cpp
	uiuc_coef_roll.cpp
	uiuc_coef_sideforce.cpp
	uiuc_coef_yaw.cpp
	uiuc_coefficients.cpp
	uiuc_controlInput.cpp
	uiuc_convert.cpp
	uiuc_engine.cpp
	uiuc_find_position.cpp
	uiuc_flapdata.cpp
	uiuc_fog.cpp
	uiuc_gear.cpp
	uiuc_get_flapper.cpp
	uiuc_getwind.cpp
	uiuc_hh_ap.cpp
	uiuc_ice.cpp
	uiuc_iceboot.cpp
	uiuc_iced_nonlin.cpp
	uiuc_icing_demo.cpp
	uiuc_initializemaps.cpp
	uiuc_map_CD.cpp
	uiuc_map_CL.cpp
	uiuc_map_CY.cpp
	uiuc_map_Cm.cpp
	uiuc_map_Cn.cpp
	uiuc_map_Croll.cpp
	uiuc_map_controlSurface.cpp
	uiuc_map_engine.cpp
	uiuc_map_fog.cpp
	uiuc_map_gear.cpp
	uiuc_map_geometry.cpp
	uiuc_map_ice.cpp
	uiuc_map_init.cpp
	uiuc_map_keyword.cpp
	uiuc_map_mass.cpp
	uiuc_map_misc.cpp
	uiuc_map_record1.cpp
	uiuc_map_record2.cpp
	uiuc_map_record3.cpp
	uiuc_map_record4.cpp
	uiuc_map_record5.cpp
	uiuc_map_record6.cpp
	uiuc_menu.cpp
	uiuc_menu_CD.cpp
	uiuc_menu_CL.cpp
	uiuc_menu_CY.cpp
	uiuc_menu_Cm.cpp
	uiuc_menu_Cn.cpp
	uiuc_menu_Croll.cpp
	uiuc_menu_controlSurface.cpp
	uiuc_menu_engine.cpp
	uiuc_menu_fog.cpp
	uiuc_menu_functions.cpp
	uiuc_menu_gear.cpp
	uiuc_menu_geometry.cpp
	uiuc_menu_ice.cpp
	uiuc_menu_init.cpp
	uiuc_menu_mass.cpp
	uiuc_menu_misc.cpp
	uiuc_menu_record.cpp
	uiuc_pah_ap.cpp
	uiuc_parsefile.cpp
	uiuc_rah_ap.cpp
	uiuc_recorder.cpp
	uiuc_warnings_errors.cpp
	uiuc_wrapper.cpp
	)
	
set(LARCSIM_SOURCES
    atmos_62.c
    basic_aero.c
    basic_engine.c
    basic_gear.c
    basic_init.c
    c172_aero.c
    c172_engine.c
    c172_gear.c
    c172_init.c
    cherokee_aero.c
    cherokee_engine.c
    cherokee_gear.c
    cherokee_init.c
    default_model_routines.c
    ls_accel.c
    ls_aux.c
    ls_geodesy.c
    ls_gravity.c
    ls_init.c
    ls_interface.c
    ls_matrix.c
    ls_model.c
    ls_step.c
    ls_trim.c
    navion_aero.c
    navion_engine.c
    navion_gear.c
    navion_init.c
    uiuc_aero.c
    IO360.cxx
    LaRCsim.cxx
    LaRCsimIC.cxx
    )
	
set(SOURCES
	NullFDM.cxx
	UFO.cxx
	fdm_shell.cxx
	flight.cxx
	flightProperties.cxx
	TankProperties.cxx
	groundcache.cxx
	${SP_FDM_SOURCES}
	ExternalNet/ExternalNet.cxx
	ExternalPipe/ExternalPipe.cxx
	)

if(ENABLE_UIUC_MODEL)
	foreach(component ${UIUC_SOURCES})
		list(APPEND SOURCES "UIUCModel/${component}")
	endforeach()
endif()

if(ENABLE_LARCSIM)
	foreach(component ${LARCSIM_SOURCES})
		list(APPEND SOURCES "LaRCsim/${component}")
	endforeach()
endif()

flightgear_component(FDM "${SOURCES}")

if(ENABLE_YASIM)
	add_subdirectory(YASim)
endif()


if(ENABLE_JSBSIM)
    add_subdirectory(JSBSim)
    
    # FIXME - push this down once JSBSim doesn't expose private headers
    include_directories(${PROJECT_SOURCE_DIR}/src/FDM/JSBSim)
endif()

=== src/GUI/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	AirportList.cxx
	MapWidget.cxx
	SafeTexFont.cxx
	WaypointList.cxx
	dialog.cxx
	FGPUIDialog.cxx
	fonts.cxx
	gui.cxx
	gui_funcs.cxx
	layout-props.cxx
	layout.cxx
	menubar.cxx
	FGPUIMenuBar.cxx
	new_gui.cxx
	property_list.cxx
	FGFontCache.cxx
	FGColor.cxx
	)

set(HEADERS
	AirportList.hxx
	MapWidget.hxx
	SafeTexFont.hxx
	WaypointList.hxx
	dialog.hxx
	FGPUIDialog.hxx
	gui.h
	layout.hxx
	menubar.hxx
	FGPUIMenuBar.hxx
	new_gui.hxx
	property_list.hxx
	FGFontCache.hxx
	FGColor.hxx
	)
    		
if (APPLE)
    list(APPEND HEADERS FGCocoaMenuBar.hxx)
    list(APPEND SOURCES FGCocoaMenuBar.mm)
endif()
    		
flightgear_component(GUI "${SOURCES}" "${HEADERS}")

=== src/Input/CMakeLists.txt ===
include(FlightGearComponent)

IF(APPLE)
	set(EVENT_INPUT_SOURCES FGMacOSXEventInput.cxx)
	set(EVENT_INPUT_HEADERS FGMacOSXEventInput.hxx)
elseif(MSVC)
	message(STATUS "EventInput not implemented for Windows yet")
else()
	set(EVENT_INPUT_SOURCES FGLinuxEventInput.cxx)
	set(EVENT_INPUT_HEADERS FGLinuxEventInput.hxx)
endif()


set(SOURCES
	FGButton.cxx
	FGCommonInput.cxx
	FGDeviceConfigurationMap.cxx
	FGEventInput.cxx
	FGJoystickInput.cxx
	FGKeyboardInput.cxx
	FGMouseInput.cxx
	input.cxx	
	)

set(HEADERS
	FGButton.hxx
	FGCommonInput.hxx
	FGDeviceConfigurationMap.hxx
	FGEventInput.hxx
	FGJoystickInput.hxx
	FGKeyboardInput.hxx
	FGMouseInput.hxx
	input.hxx
	)

if(EVENT_INPUT)
	list(APPEND SOURCES ${EVENT_INPUT_SOURCES})
	list(APPEND SOURCES ${EVENT_INPUT_HEADERS})
	include_directories(${UDEV_INCLUDE_DIR})
	add_definitions(-DWITH_EVENTINPUT)
endif()

set(FGJS_SOURCES
	fgjs.cxx
	jsinput.cxx
	jssuper.cxx
	)

add_executable(fgjs ${FGJS_SOURCES})

target_link_libraries(fgjs 
	${SIMGEAR_CORE_LIBRARIES}
	${PLIB_LIBRARIES}
	${SIMGEAR_CORE_LIBRARY_DEPENDENCIES})

add_executable(js_demo js_demo.cxx)

target_link_libraries(js_demo 
	${SIMGEAR_CORE_LIBRARIES}
	${PLIB_LIBRARIES}
	${SIMGEAR_CORE_LIBRARY_DEPENDENCIES})

flightgear_component(Input "${SOURCES}" "${HEADERS}")

install(TARGETS fgjs js_demo RUNTIME DESTINATION bin)

=== src/Main/CMakeLists.txt ===

if (MSVC)
	if (CMAKE_CL_64)
		set( RESOURCE_FILE flightgear64.rc )
	else (CMAKE_CL_64)
		set( RESOURCE_FILE flightgear.rc )
	endif (CMAKE_CL_64)
endif (MSVC)

set(SOURCES
	CameraGroup.cxx
	FGEventHandler.cxx
	WindowBuilder.cxx
	WindowSystemAdapter.cxx
	bootstrap.cxx
	fg_commands.cxx
	fg_init.cxx
	fg_io.cxx
	fg_os_common.cxx
	fg_os_osgviewer.cxx
	fg_props.cxx
	fgviewer.cxx
	globals.cxx
	logger.cxx
	main.cxx
	options.cxx
	renderer.cxx
	splash.cxx
	util.cxx
	viewer.cxx
	viewmgr.cxx
	${RESOURCE_FILE}
	)

set(HEADERS
	CameraGroup.hxx
	FGEventHandler.hxx
	WindowBuilder.hxx
	WindowSystemAdapter.hxx
	fg_commands.hxx
	fg_init.hxx
	fg_io.hxx
	fg_props.hxx
	fgviewer.hxx
	globals.hxx
	logger.hxx
	main.hxx
	options.hxx
	renderer.hxx
	splash.hxx
	util.hxx
	viewer.hxx
	viewmgr.hxx
	)

add_executable(fgfs ${SOURCES} ${HEADERS})

get_property(FG_LIBS GLOBAL PROPERTY FG_LIBS)
#message(STATUS "fg libs ${FG_LIBS}")
#message(STATUS "OSG libs ${OPENSCENEGRAPH_LIBRARIES}")
#message(STATUS "SG libs ${SIMGEAR_LIBRARIES}")

if(RTI_FOUND)
	find_sg_component(hla SIMGEAR_LIBRARIES)
	find_sg_component(rti13 SIMGEAR_LIBRARIES)
	find_sg_component(rti SIMGEAR_LIBRARIES)
	set(HLA_LIBRARIES ${RTI_LIBRARIES})
else()
	set(HLA_LIBRARIES "")
endif()

target_link_libraries(fgfs
	${FG_LIBS}
	${SIMGEAR_LIBRARIES}
	${OPENSCENEGRAPH_LIBRARIES}
	${OPENGL_LIBRARIES}
	${PLIB_LIBRARIES}
	${JPEG_LIBRARY}
	${HLA_LIBRARIES}
	${EVENT_INPUT_LIBRARIES}
	${SIMGEAR_CORE_LIBRARY_DEPENDENCIES}
	${SIMGEAR_SCENE_LIBRARY_DEPENDENCIES}
	${PLATFORM_LIBS}
)

install(TARGETS fgfs RUNTIME DESTINATION bin)

check_library_exists(rt clock_gettime "" HAVE_CLOCK_GETTIME)
add_executable(metar metar_main.cxx)
if(HAVE_CLOCK_GETTIME)
        target_link_libraries(metar rt)
endif(HAVE_CLOCK_GETTIME)
target_link_libraries(metar
	${SIMGEAR_LIBRARIES}
	${SIMGEAR_CORE_LIBRARY_DEPENDENCIES}
	${SIMGEAR_SCENE_LIBRARY_DEPENDENCIES}
	${PLATFORM_LIBS}
)

install(TARGETS metar RUNTIME DESTINATION bin)

=== src/Model/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	acmodel.cxx
	model_panel.cxx
	modelmgr.cxx
	panelnode.cxx
	)

set(HEADERS
	acmodel.hxx
	model_panel.hxx
	modelmgr.hxx
	panelnode.hxx
	)
    		
flightgear_component(Model "${SOURCES}" "${HEADERS}")

=== src/Navaids/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	airways.cxx
	fixlist.cxx
	markerbeacon.cxx
	navdb.cxx
	navlist.cxx
	navrecord.cxx
	positioned.cxx
	procedure.cxx
	route.cxx
	routePath.cxx
	waypoint.cxx
	PositionedBinding.cxx
	)

set(HEADERS
    airways.hxx
	fixlist.hxx
	markerbeacon.hxx
	navdb.hxx
	navlist.hxx
	navrecord.hxx
	positioned.hxx
	procedure.hxx
	route.hxx
	routePath.hxx
	waypoint.hxx
	PositionedBinding.hxx
    )

flightgear_component(Navaids "${SOURCES}" "${HEADERS}")

=== src/Radio/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	antenna.cxx
	radio.cxx
	itm.cpp
	)

set(HEADERS
	antenna.hxx
	radio.hxx
	)

	
flightgear_component(Radio "${SOURCES}" "${HEADERS}")

=== src/Scenery/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	SceneryPager.cxx
	redout.cxx
	scenery.cxx
	tilemgr.cxx
	)

set(HEADERS
	SceneryPager.hxx
	redout.hxx
	scenery.hxx
	tilemgr.hxx
	)
    		
flightgear_component(Scenery "${SOURCES}" "${HEADERS}")

=== debian/changelog ===
flightgear (2.6.0-1build1) raring; urgency=low

  * No-change rebuild against libudev1

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 13 Mar 2013 07:07:38 +0000

flightgear (2.6.0-1) unstable; urgency=low

  * New upstream release.
  * Depend on cmake. No longer depend on autotools-dev.
  * Updated debian/rules for the new cmake-based build
    system used by upstream, and cleaned it up a bit.
  * Switched source package format to 3.0 (quilt).
  * Added build-dependencies on libplib-dev, libudev-dev,
    and libpng12-dev.

 -- Ove Kaaven <ovek@arcticnet.no>  Mon, 16 Jul 2012 06:01:36 +0200

flightgear (2.4.0-1.2) unstable; urgency=high

  * Non-maintainer upload.
  * Fix FTBFS with svn 1.7 by adding missing include statement. (Closes: #678783).
  * Set urgency=high to fix the RC bug.

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 27 Jun 2012 17:39:22 +0200

flightgear (2.4.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix build failure with GCC 4.7.  Closes: #667167.
    - utils/TerraSync/terrasync.cxx: Include <unistd.h> for
      write, getpid, sleep.

 -- Matej Vela <vela@debian.org>  Sun, 20 May 2012 01:38:16 +0100

flightgear (2.4.0-1) unstable; urgency=low

  * New upstream release. Closes: #638588.
  * Build-Depend on OpenSceneGraph 3.0, and the Subversion library.
  * Recommend fgfs-scenery-base.
  * Enable parallel builds (shorter compile times on multicore CPUs).
  * Removed hack that tried to build without optimizations if
    building with optimizations fails.

 -- Ove Kaaven <ovek@arcticnet.no>  Sat, 03 Sep 2011 22:16:12 +0200

flightgear (2.0.0-4) unstable; urgency=low

  * Backported a bunch of upstream commits (from their git tree)
    for support of newer versions of OpenSceneGraph:
    f901dac 4b2436a c5366cc b692a16 473cea7
    Closes: #634424

 -- Ove Kaaven <ovek@arcticnet.no>  Fri, 22 Jul 2011 01:58:19 +0200

flightgear (2.0.0-3) unstable; urgency=low

  * Recommend fgfs-aircraft-base and fgfs-models-base.
    Closes. #610276.
  * Added note about scenery SharedModels.tgz to README.Debian.

 -- Ove Kaaven <ovek@arcticnet.no>  Sun, 30 Jan 2011 15:46:35 +0100

flightgear (2.0.0-2) unstable; urgency=low

  * Build-Depend on simgear 2.0.0-2, which hopefully now
    builds correctly.
  * Also remember to use pbuilder. Closes: #609572.

 -- Ove Kaaven <ovek@arcticnet.no>  Tue, 11 Jan 2011 04:24:20 +0100

flightgear (2.0.0-1) unstable; urgency=low

  * New upstream release. Closes: #573037.
  * Add ${misc:Depends} to debian/control.

 -- Ove Kaaven <ovek@arcticnet.no>  Sun, 03 Oct 2010 19:39:36 +0200

flightgear (1.9.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: UGear_command.cxx:41: error: 'snprintf' was not declared in
    this scope". Applied patch by Cyril Brulebois (Closes: #560494)

 -- Bastian Venthur <venthur@debian.org>  Sun, 21 Feb 2010 16:40:20 +0100

flightgear (1.9.1-1) unstable; urgency=low

  * New upstream release. Closes: #510387.
  * Updated debian/control and things for FlightGear 1.9.1.
    This includes depending on plib 1.8.5. Closes: #528635.
  * Added Vcs-Browser and Vcs-Svn fields to debian/control.
  * Converted debian/watch to version 3. Closes: #529110.

 -- Ove Kaaven <ovek@arcticnet.no>  Sun, 14 Jun 2009 21:35:48 +0200

flightgear (1.0.0-3) unstable; urgency=low

  * Made the pkg-fgfs-crew mailing list the official maintainer of the
    FlightGear package, and myself a mere uploader.
  * Updated libglut3-dev build-dependency to freeglut3-dev. Closes:
    #394491.

 -- Ove Kaaven <ovek@arcticnet.no>  Sat, 21 Jun 2008 14:10:28 +0200

flightgear (1.0.0-2) unstable; urgency=low

  * Added Homepage field.
  * Added flightgear.desktop file by Lukas Fittl. Closes: #409683.
  * Build-Depend on simgear-dev 1.0.0-3 or later.
  * Reverted all Debian patches to upstream's makefiles;
    with simgear 1.0.0-3 they shouldn't be needed anymore.
  * Use debian/compat file instead of setting DH_COMPAT in debian/rules.
    Upgraded DH build-dependency and compatibility level to 5.
  * Set optimization level according to DEB_BUILD_OPTIONS.
  * No longer clear -g according to DEB_BUILD_OPTIONS, leave that
    to dh_strip.
  * Upgraded Standards-Version to 3.7.3.
  * Cleaned debian/rules by removing a whole lot of unnecessary
    dh_* calls (originally from the dh_make template).

 -- Ove Kaaven <ovek@arcticnet.no>  Thu, 10 Apr 2008 10:13:54 +0200

flightgear (1.0.0-1) unstable; urgency=low

  * New upstream release.

 -- Ove Kaaven <ovek@arcticnet.no>  Sat, 22 Dec 2007 15:39:49 +0100

flightgear (0.9.10-2) unstable; urgency=low

  * Updated the build dependencies for xorg 7.0. Apparently the
    amd64 autobuilder doesn't use Provides.

 -- Ove Kaaven <ovek@arcticnet.no>  Wed, 17 May 2006 17:12:09 -0400

flightgear (0.9.10-1) unstable; urgency=low

  * New upstream release.

 -- Ove Kaaven <ovek@arcticnet.no>  Fri,  5 May 2006 20:02:30 -0400

flightgear (0.9.9-2) unstable; urgency=low

  * Apply patch from Martin Michlmayr and upstream CVS for
    g++ 4.1 build failure. Closes: #356598.
    (Martin also reported a link failure, but I see no reason
    that should happen in a clean build, and upstream doesn't
    seem to have had that kind of issue either, so he probably
    just got a misbuild from his experimentations.)
  * Build-Depend on libalut-dev, and simgear 0.3.9-3.

 -- Ove Kaaven <ovek@arcticnet.no>  Sun, 19 Mar 2006 06:47:39 -0500

flightgear (0.9.9-1) unstable; urgency=low

  * New upstream release. Closes: #341727.
    Includes completely rewritten 3D clouds. Closes: #330861.
    (Other stuff: a working aircraft carrier, new aircraft,
    high-G blackouts, better weather, improved multiplayer,
    and much more.)

 -- Ove Kaaven <ovek@arcticnet.no>  Mon,  2 Jan 2006 15:49:28 -0500

flightgear (0.9.8-3) unstable; urgency=low

  * Built with gcc-4.0-compiled simgear.

 -- Ove Kaaven <ovek@arcticnet.no>  Mon, 25 Jul 2005 03:30:24 -0400

flightgear (0.9.8-2) unstable; urgency=low



=== debian/control ===
Source: flightgear
Section: games
Priority: extra
Maintainer: Debian FlightGear Crew <pkg-fgfs-crew@lists.alioth.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>
Build-Depends: debhelper (>> 5),
 libx11-dev, libxext-dev, libxi-dev, libice-dev, libsm-dev, libxt-dev, libxmu-dev,
 libgl1-mesa-dev | xlibmesa-gl-dev | libgl-dev,
 libglu1-mesa-dev | libglu1-xorg-dev | xlibmesa-glu-dev | libglu-dev,
 freeglut3-dev | libglut3-dev, zlib1g-dev, libjpeg8-dev | libjpeg62-dev | libjpeg-dev,
 libpng12-dev | libpng3-dev | libpng-dev, libboost-dev, libplib-dev (>= 1.8.5),
 libopenscenegraph-dev (>> 3.0.0), libopenal-dev, libalut-dev, libsvn-dev,
 libudev-dev, cmake (>= 2.6), simgear-dev (>= 2.6.0-1)
Standards-Version: 3.7.3
Homepage: http://www.flightgear.org/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-fgfs/flightgear/trunk/
Vcs-Svn: svn://svn.debian.org/pkg-fgfs/flightgear/trunk/

Package: flightgear
Architecture: any
Depends: ${shlibs:Depends}, fgfs-base (>= 2.6.0), ${misc:Depends}
Recommends: fgfs-aircraft-base (>= 2.6.0), fgfs-models-base (>= 2.6.0),
 fgfs-scenery-base (>= 2.6.0)
Description: Flight Gear Flight Simulator
 Flight Gear is a free and highly sophisticated flight simulator.
 .
 This package contains the runtime binaries.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS=-O0 -g -D_REENTRANT
else
CFLAGS=-O2 -g -D_REENTRANT
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
endif

CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_INSTALL_BINDIR:PATH=games \
	-DFG_DATA_DIR:PATH=/usr/share/games/flightgear \
	-DSIMGEAR_SHARED:BOOL=ON \
	-DJPEG_FACTORY=ON \
	-DENABLE_FGADMIN=OFF \
	-DENABLE_LARCSIM=ON \
	-DENABLE_UIUC_MODEL=ON \
	-DSP_FDMS=ON

configure: configure-stamp
configure-stamp:
	dh_testdir

	mkdir build
	cd build && \
	CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)" \
	cmake .. $(CMAKE_FLAGS)

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp: configure-stamp
	dh_testdir

	cd build && $(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	rm -rf build

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build && \
	$(MAKE) install DESTDIR=$(CURDIR)/debian/flightgear

	# the CMAKE_INSTALL_BINDIR might be ignored
	if [ -d debian/flightgear/usr/bin ]; then \
	  mv debian/flightgear/usr/bin/* debian/flightgear/usr/games; \
	fi

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot

	dh_install

	dh_installdocs
	cp docs-mini/* debian/flightgear/usr/share/doc/flightgear || true
	cp utils/TerraSync/README.txt debian/flightgear/usr/share/doc/flightgear/README.TerraSync
	dh_installmenu
	dh_installchangelogs ChangeLog
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
#ftp://ftp.flightgear.org/pub/fgfs/Source/flightgear-(.*)\.tar\.bz2
ftp://mirrors.ibiblio.org/pub/mirrors/flightgear/ftp/Source/flightgear-(.*)\.tar\.bz2
